;; The first three lines of this file were inserted by DrScheme.
;; They record information about the language level.
#reader(lib "plai-pretty-big-reader.ss" "plai")((modname rcfae) (read-case-sensitive #t) (teachpacks ()))
(define-type RCFAE
  [num (n number?)]
  [add (l RCFAE?) (r RCFAE?)]
  [sub (l RCFAE?) (r RCFAE?)]
  [mult (l RCFAE?) (r RCFAE?)]
  [id (v symbol?)]
  [fun (arg symbol?) (body RCFAE?)]
  [app (fun-expr RCFAE?) (arg RCFAE?)]
  [if0 (test RCFAE?) (truth RCFAE?) (falsity RCFAE?)]
  [-rec (id symbol?) (expr RCFAE?) (body RCFAE?)])

(define-type RCFAE-Value
  [numV (n number?)]
  [closureV (param symbol?)
            (body RCFAE?)
            (env Env?)])

(define (boxed-RCFAE-Value? v)
  (and (box? v)
       (RCFAE-Value? (unbox v))))

(define-type Env
  [mtSub]
  [aSub (name symbol?)
        (value RCFAE-Value?)
        (env Env?)]
  [aRecSub (name symbol?)
           (value boxed-RCFAE-Value?)
           (env Env?)])

;; lookup : symbol env! RCFAE-Value
(define (lookup name env)
  (type-case Env env
    [mtSub () (error 'lookup (format "no binding for identifier: ~s" name))]
    [aSub (bound-name bound-value rest-env)
          (if (symbol=? bound-name name)
              bound-value
              (lookup name rest-env))]
    [aRecSub (bound-name boxed-bound-value rest-env)
             (if (symbol=? bound-name name)
                 (unbox boxed-bound-value)
                 (lookup name rest-env))]))

;; cyclically-bind-and-interp : symbol RCFAE env! env
(define (cyclically-bind-and-interp bound-id named-expr env)
  (local ([define value-holder (box (numV 1729))]
          [define new-env (aRecSub bound-id value-holder env)]
          [define named-expr-val (interp named-expr new-env)])
    (begin
      (set-box! value-holder named-expr-val)
      new-env)))

(define (num+ n m)
  (numV (+ (numV-n n) (numV-n m))))

(define (num- n m)
  (numV (- (numV-n n) (numV-n m))))

(define (num* n m)
  (numV (* (numV-n n) (numV-n m))))

(define (num-zero? n)
  (zero? (numV-n n)))

;; parse : sexp -> RCFAE
(define (parse sexp)
  (cond 
    [(number? sexp) (num sexp)]
    [(symbol? sexp) (id sexp)]
    [(list? sexp)
     (case (first sexp)
       [(+) (add (parse (second sexp)) (parse (third sexp)))]
       [(-) (sub (parse (second sexp)) (parse (third sexp)))]
       [(*) (mult (parse (second sexp)) (parse (third sexp)))]
       [(if0) (if0 (parse (second sexp)) (parse (third sexp)) (parse (fourth sexp)))]
       [(fun) (fun (first (second sexp)) (parse (third sexp)))]
       [(rec) (-rec (first (second sexp)) (parse (second (second sexp))) (parse (third sexp)))]
       [else (app (parse (first sexp)) (parse (second sexp)))])]))
    


;; interp : RCFAE env! RCFAE-Value
(define (interp expr env)
  (type-case RCFAE expr
    [num (n) (numV n)]
    [add (l r) (num+ (interp l env) (interp r env))]
    [sub (l r) (num- (interp l env) (interp r env))]    
    [mult (l r) (num* (interp l env) (interp r env))]
    [if0 (test truth falsity)
         (if (num-zero? (interp test env))
             (interp truth env)
             (interp falsity env))]
    [id (v) (lookup v env)]
    [fun (bound-id bound-body)
         (closureV bound-id bound-body env)]
    [app (fun-expr arg-expr)
         (local ([define fun-val (interp fun-expr env)])
           (interp (closureV-body fun-val)
                   (aSub (closureV-param fun-val)
                         (interp arg-expr env)
                         (closureV-env fun-val))))]
    [-rec (bound-id named-expr bound-body)
      (interp bound-body
              (cyclically-bind-and-interp bound-id
                                          named-expr
                                          env))]))


;; TEST
(interp (parse '{rec {fact {fun {n}
                                {if0 n
                                     1
                                     {* n {fact {- n 1}}}}}}
                  {fact 10}}) (mtSub))

{interp (parse '{rec {fib {fun {n}
                               {if0 n
                                    0
                                    {if0 {- n 1}
                                         1
                                         {+ {fib {- n 1}} {fib {- n 2}}}}}}}
                  {fib 10}})
        (mtSub)}
                                         
                                       